Package org.globus.gsi.gssapi.net

# Class GssInputStream

java.lang.Object
java.io.InputStream
org.globus.gsi.gssapi.net.GssInputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

Direct Known Subclasses:
  `GridFTPInputStream`, `GSIGssInputStream`

public abstract class GssInputStream extends InputStream

## Field Summary

Fields
Modifier and Type
Field
Description
`protected byte[]`
`buff`
`protected GSSContext`
`context`
`protected InputStream`
`in`
`protected int`
`index`

## Constructor Summary

Constructors
Constructor
Description
`GssInputStream(InputStream in, GSSContext context)`

## Method Summary

Modifier and Type
Method
Description
`int`
`available()`
`void`
`close()`
`protected boolean`
`hasData()`
`int`
`read()`
`int`
`read(byte[] data)`
`int`
`read(byte[] data, int off, int len)`
`protected abstract void`
`readMsg()`
`protected byte[]`
`unwrap(byte[] msg)`

### Methods inherited from class java.io.InputStream

`mark, markSupported, nullInputStream, readAllBytes, readNBytes, readNBytes, reset, skip, skipNBytes, transferTo`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### in

protected InputStream in

### context

protected GSSContext context

### buff

protected byte[] buff

### index

protected int index

## Constructor Details

### GssInputStream

public GssInputStream(InputStream in, GSSContext context)

## Method Details

### unwrap

protected byte[] unwrap(byte[] msg) throws IOException

Throws:
  `IOException`

### readMsg

protected abstract void readMsg() throws IOException

Throws:
  `IOException`

### read

public int read(byte[] data) throws IOException

Overrides:
  `read` in class `InputStream`
Throws:
  `IOException`

### read

public int read(byte[] data, int off, int len) throws IOException

Overrides:
  `read` in class `InputStream`
Throws:
  `IOException`

### read

public int read() throws IOException

Specified by:
  `read` in class `InputStream`
Throws:
  `IOException`

### hasData

protected boolean hasData() throws IOException

Throws:
  `IOException`

### close

public void close() throws IOException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Overrides:
  `close` in class `InputStream`
Throws:
  `IOException`

### available

public int available() throws IOException

Overrides:
  `available` in class `InputStream`
Throws:
  `IOException`